from Cenario import Cenario
from direct.showbase.DirectObject import DirectObject
from abc import abstractmethod
from panda3d.core import TransparencyAttrib

class MiniGame (Cenario, DirectObject):
    '''
        Classe que encapsula as caracteristicas dos mini-games.
    '''

    def __init__(self, jogadores):
        self.jogadores = jogadores
        self.accept('FimDeJogo', self.exit)
    
    def bolaPos (self, x, y, z) :
        pass
    
    def exit (self) :
        self.finaliza()
        self.limpa()
        
    def run (self):
        self.carrega()
        self.inicia()
        
    @abstractmethod
    def carrega (self):
        raise NotImplementedError
    
    @abstractmethod    
    def inicia (self):
        raise NotImplementedError
    
    @abstractmethod
    def finaliza (self):
        raise NotImplementedError
    
    @abstractmethod
    def loop (self) :
        raise NotImplementedError
    
    @abstractmethod
    def limpa (self) :
        raise NotImplementedError
