# -*- coding: utf-8 -*-
from direct.showbase.DirectObject import DirectObject
import sys
from Teclado import Teclado
from panda3d.core import TextNode, NodePath, PandaNode
from direct.actor.Actor import Actor
from rede.Servidor import Servidor

class TelaCria(DirectObject):
    def __init__(self, menu, main):
        self.accept("guest", self.guestIn)
        base.setBackgroundColor(0.4,0.4,0.6)
        menu.menu.remove()
        self.main = main
        self.main.rede = Servidor()
        self.main.rede.start()
        self.keyMap = {"enter" : 0}
        
        self.titulo = TextNode('titulo') 
        self.tituloNodePath = aspect2d.attachNewNode(self.titulo) 
        self.tituloNodePath.setScale(0.15) 
        self.tituloNodePath.setPos(0,0,0.75)
        self.titulo.setAlign(TextNode.ACenter)
        self.titulo.setShadow(0.05, 0.05)
        self.titulo.setShadowColor(0, 0, 0, 1)

        self.sub = TextNode('subtitulo')
        self.subNodePath = aspect2d.attachNewNode(self.sub)
        self.subNodePath.setScale(0.10)
        self.subNodePath.setPos(-1.2,0,0.4)
        self.sub.setTextColor(0,0,0,1)
        self.sub.setShadow(0.05,0.05)
        self.sub.setShadowColor(1,1,1,1)
        
        self.instr = TextNode('instrucoes')
        self.instrNodePath = aspect2d.attachNewNode(self.instr)
        self.instrNodePath.setScale(0.07)
        self.instrNodePath.setPos(-1.2,0,-0.8)
        self.titulo.setShadow(0.05, 0.05)
        self.titulo.setShadowColor(0, 0, 0, 1)
        
        self.ip = TextNode('ip')
        self.ip.setTextColor(0,0,0,1)
        self.ipNodePath = aspect2d.attachNewNode(self.ip)
        self.ipNodePath.setScale(0.07)
        self.ipNodePath.setPos(0.7,0,0.4)
        self.ip.setShadow(0.05,0.05)
        self.ip.setShadowColor(1,1,1,1)
       
        self.guest = TextNode('convidado')
        self.guestNodePath = aspect2d.attachNewNode(self.guest)
        self.guestNodePath.setScale(0.07)
        self.guestNodePath.setPos(-1.1, 0, 0.25)
        self.ip.setShadow(0.05,0.05)
        self.ip.setShadowColor(0,0,0,1)
        
        
        self.hostName = TextNode('hostname')
        self.hostName.setTextColor(0,0,0,1)
        self.hostNodePath = aspect2d.attachNewNode(self.hostName)
        self.hostNodePath.setScale(0.07)
        self.hostNodePath.setPos(0.8, 0, 0.25)
        self.hostName.setShadow(0.05,0.05)
        self.hostName.setShadowColor(1,1,1,1)
        
        self.ralph = Actor("../modelos/ralph",
                                 {"run":"../modelos/ralph-run",
                                  "walk":"../modelos/ralph-walk"})
        self.ralph.setScale(.1)
        self.ralph.setPos(1,0,-1)
        self.ralph.setH(-90)
        self.ralph.reparentTo(render)
        self.ralph.loop("walk")
        
        
        self.escreve(self.hostName, self.main.rede.getHostName())
        self.escreve(self.titulo, "Aguardando Jogadores")
        self.escreve(self.sub, "Jogadores")
        self.escreve(self.instr, "Aperte Enter para iniciar a partida")
        self.escreve(self.ip, "Seu host name e'")
        
        self.accept("enter",         self.setKey, ["enter",        1])
        taskMgr.add(self.esperaInicio, "espera inicio")
        
        
    def IniciarPartida(self):
        self.main.inicia()

    def setKey(self, key, value):
        self.keyMap[key] = value
        
    def escreve(self, node, msg):
        node.setText(msg)
        
    def guestIn(self, nome):
        self.ralph.loop("run")
        self.escreve(self.guest, nome)
        
    def esperaInicio(self, task):
        if (self.keyMap["enter"] != 0):
            self.keyMap["enter"] = 0
            aspect2d.reparentTo(hidden)
            self.main.rede.enviaTransicao()
            self.main.inicia()
            return task.done
            
        return task.cont 