from direct.showbase.DirectObject import DirectObject
import sys
from Teclado import Teclado
from panda3d.core import TextNode, NodePath, PandaNode
from direct.actor.Actor import Actor
from direct.gui.OnscreenText import OnscreenText
from direct.gui.DirectGui import DirectEntry
from pandac.PandaModules import Point3
from rede.Cliente import Cliente

class TelaProcura(DirectObject):
    def __init__(self, menu, main):
        menu.menu.remove()
        base.setBackgroundColor(0.4,0.4,0.6)
        self.accept("comecou", self.fecha)
        self.main = main
        self.keyMap = {"enter" : 0}
        self.preencheu = False
        self.ip = ""
        self.conteudo = ""
        
        self.titulo = TextNode('titulo') 
        tituloNodePath = aspect2d.attachNewNode(self.titulo) 
        tituloNodePath.setScale(0.15) 
        tituloNodePath.setPos(0,0,0.75)
        self.titulo.setAlign(TextNode.ACenter)
        self.titulo.setShadow(0.05, 0.05)
        self.titulo.setShadowColor(0, 0, 0, 1)

        self.sub = TextNode('subtitulo2')
        subNodePath = aspect2d.attachNewNode(self.sub)
        subNodePath.setScale(0.10)
        subNodePath.setPos(0,0,0.2)
        self.sub.setAlign(TextNode.ACenter)
        self.sub.setTextColor(0,0,0,1)
        self.sub.setShadow(0.05,0.05)
        self.sub.setShadowColor(1,1,1,1)
        
        self.status = TextNode('status')
        statusNodePath = aspect2d.attachNewNode(self.status)
        statusNodePath.setScale(0.1)
        statusNodePath.setPos(-0.75,0,-0.8)
        self.status.setTextColor(0,0,0,1)
        self.status.setShadow(0.05,0.05)
        self.status.setShadowColor(0,0,0,1)
       
        #self.ralph = Actor("../modelos/ralph",
        #                         {"run":"../modelos/ralph-run",
        #                          "walk":"../modelos/ralph-walk"})
        #self.ralph.setScale(.1)
        #self.ralph.setPos(0,0,0)
        #self.floater = NodePath(PandaNode("floater"))
        #self.floater.reparentTo(render)
        #self.ralph.loop("run")
        self.ralph = Actor("../modelos/ralph",
                                 {"run":"../modelos/ralph-run",
                                  "walk":"../modelos/ralph-walk"})
        self.ralph.setScale(.1)
        self.ralph.setPos(1,0,-1)
        self.ralph.setH(-90)
        self.ralph.reparentTo(render)
        self.ralph.loop("run")
        
        self.teclado = Teclado()
        self.escreve(self.titulo, "Procurar servidor")
        self.escreve(self.sub, "Digite o hostname e pressione Enter")

        self.accept("enter",         self.setKey, ["enter",        1])
        taskMgr.add(self.esperaInicio, "espera inicio")
        
        
    def IniciarPartida(self):
        self.main.rede.start()
#        self.main.inicia()

    def setKey(self, key, value):
        self.keyMap[key] = value
        
    def escreve(self, node, msg):
        node.setText(msg)  
        
    def fecha(self):
        aspect2d.reparentTo(hidden)
                
    def esperaInicio(self, task):
        if (self.keyMap["enter"] != 0):
            self.keyMap["enter"] = 0
            self.conteudo = self.teclado.getMsg()
            if(self.preencheu == False):
                print self.conteudo
                if(len(self.conteudo) > 0):
                    self.ip = self.conteudo
                    self.preencheu = True
                    self.conteudo = ""
                    self.main.rede = Cliente(self.ip)
                    self.escreve(self.status, "Sucesso! Aguardando servidor")
                    self.IniciarPartida()
                    return task.done
            
        return task.cont 