from direct.distributed.PyDatagram import PyDatagram

# Mensagens
ID_MSG = 0
POSITION_MSG = 1
MINIGAME_MSG = 2
TRANSICAO_MSG = 3
SYNC_MSG = 4
BOLA_MSG = 5
END_MSG = 6

BROADCAST_MSG = -1

# Configuracao da conexao
portAddress = 9099
timeout = 3000
ipAddress = 'localhost'

#Limite de tentativas de conexao antes de comecar a rejeita-las
backlog = 1000

def createMsgPosicao (id, key, value) :
    datagram = PyDatagram()
    datagram.addInt8(POSITION_MSG)
    datagram.addInt8(id)
    datagram.addInt8(BROADCAST_MSG)
    datagram.addString(key)
    datagram.addInt8(value)
    
    return datagram

def createMsgMiniGame (id) :
    datagram = PyDatagram()
    datagram.addInt8(MINIGAME_MSG)
    datagram.addInt8(id)
    datagram.addInt8(BROADCAST_MSG)
    datagram.addString("MiniGame")
        
    return datagram

def createMsgTransicao (id) :
    datagram = PyDatagram()
    datagram.addInt8(TRANSICAO_MSG)
    datagram.addInt8(id)
    datagram.addInt8(BROADCAST_MSG)
    datagram.addString("Transicao")
    
    return datagram

def createMsgSync (id, pos, hpr) :
    x, y, z = pos
    h, p, r = hpr
    datagram = PyDatagram()
    datagram.addInt8(SYNC_MSG)
    datagram.addInt8(id)
    datagram.addInt8(BROADCAST_MSG)
    datagram.addFloat32(x)
    datagram.addFloat32(y)
    datagram.addFloat32(z)
    datagram.addFloat32(h)
    datagram.addFloat32(p)
    datagram.addFloat32(r)
    
    return datagram

def createMsgBola (id, pos) :
    x, y, z = pos
    datagram = PyDatagram()
    datagram.addInt8(BOLA_MSG)
    datagram.addInt8(id)
    datagram.addInt8(BROADCAST_MSG)
    datagram.addFloat32(x)
    datagram.addFloat32(y)
    datagram.addFloat32(z)
    
    return datagram

def createMsgFim (id) :
    datagram = PyDatagram()
    datagram.addInt8(END_MSG)
    datagram.addInt8(id)
    datagram.addInt8(BROADCAST_MSG)
    
    return datagram